' BallGame modified To show New v5 skinmesh And effect shader functionality.

' Because SkinMeshes can now be created from both bone-animated And static meshes,
' the old ...MeshCreate() functions are now deprecated And only kept For backward
' compatibility.

' Because only skinmeshes support programmable .fx shaders you should always use
' ...SkinMeshCreate() functions instead of ...MeshCreate() functions.

SuperStrict
Framework _3Impact.Lib

Global Camera:CAMERA
Global LoadingMessage:SPRITE
Global SkyBox:SKYBOX
Global Terrain:BODY
Global TerrainMesh:SKINMESH
Global Ball:BODY
Global BallMesh:SKINMESH
Global BallMeshShadow:MESH
Global BallTerrain:BODYBODY

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()
		Camera=iCameraCreate(0.0,0.0,1.0,1.0)
		iCameraLocationSet(Camera,_D3DXVECTOR3(0.0,3.0,-10.0))
		
		iLightDirectionalSet(_D3DXVECTOR3(1.0,-1.0,1.0),_D3DXVECTOR4(1.0,1.0,1.0,0.35))
		
		LoadingMessage=iSpriteCreate("default_res\\sprites\\loading.x",Null)
		iSpriteRender(LoadingMessage,False)
		
		SkyBox=iSkyBoxCreate("default_res\\skyboxes\\skybox01.sky")
		
		Terrain=iBodyCreate("default_res\\terrain_5.00.ply")
		' We create the static terrain mesh as a skinmesh. Note that this Function
		' now requires a New parameter. This is the .fx/.fxo file To use To render
		' the mesh. We set this parameter To Null as we are using the Default .fx shader.

		TerrainMesh=iBodySkinMeshCreate("default_res\\terrain.x",Null,Terrain)

		Ball=iBodySGCreate("default_res\\ball_.spg",0.13)
		' We create the ball mesh as a skinmesh too, but we specify a custom shader
		' For it. It is basically a simple modification of the Default one. You can
		' open the alpha.fx file with a text editor For details on this modification.

		BallMesh=iBodySkinMeshCreate("default_res\\ball.x","fxShaders\\alpha.fx",Ball)
		iBodyLocationSet(Ball,_D3DXVECTOR3(0.0,5.0,0.0),True)
		iBodyDampingSet(Ball,0.0,0.999,0.0,0.995)
		
		BallMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ball_shadow.x",Ball,500.0)
		
		BallTerrain=iBodyBodyCreate(Ball,Terrain)
		iBodyBodyFrictionSet(BallTerrain,10.0)
		
		iBodyEnable(Terrain)
		iBodyEnable(Ball)
		
		iSpriteHide(LoadingMessage)
		iSkyBoxShow(SkyBox)
		iSkinMeshShow(TerrainMesh)
		iSkinMeshShow(BallMesh)
		iMeshShow(BallMeshShadow)
	EndMethod

	Method _Run()
		Local cameratarget:D3DXVECTOR3=_D3DXVECTOR3()		
		iBodyLocationCM(Ball,cameratarget)
		iCameraLookAt(Camera,cameratarget,0.1)

		Local acceleration:D3DXVECTOR3=_D3DXVECTOR3()
		Local cameraorientation:D3DXQUATERNION=_D3DXQUATERNION()
					
		acceleration=_D3DXVECTOR3(0.0,0.0,0.0)

		If (iKeyDown(DIK_LEFT)) acceleration.PlusEq(_D3DXVECTOR3(-10.0,0.0,0.0))
		If (iKeyDown(DIK_RIGHT)) acceleration.PlusEq(_D3DXVECTOR3(10.0,0.0,0.0))
		If (iKeyDown(DIK_UP)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,10.0))
		If (iKeyDown(DIK_DOWN)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,-10.0))
			
		iCameraOrientation(Camera,cameraorientation)
		iVectorRotate(acceleration,acceleration,cameraorientation)
		
		acceleration.y = 0.0
		
		iBodyAccelerationApply(Ball,acceleration)

		If Not iKeyDown(DIK_LCONTROL)
		   iBodyAccelerationApply(Ball,_D3DXVECTOR3(0.0,-9.80665,0.0))
		Else 
		   iBodyAccelerationApply(Ball,_D3DXVECTOR3(0.0,9.80665,0.0))
		EndIf
				
		' We must pass the additional alpha factor To the shader run-time, at every Run() loop
		Local alpha:Float = 0.5
		iSkinMeshEffectValueSet(BallMesh,"fAlpha",Varptr(alpha),4)
	EndMethod
	
EndType

