' Skinned ragdoll shaders demo.

' NOTE: in our code comments we assume you understand the SkinnedRagdoll sample code.

' THIS SOURCE CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. USE AT YOUR OWN RISK.

Strict
Framework _3Impact.Lib

Global Camera:CAMERA
Global LoadingMessage:SPRITE
Global SkyBox:SKYBOX
Global Terrain:BODY
Global TerrainMesh:MESH

Global Head:BODY
Global HeadMeshShadow:MESH

Global Chest:BODY
Global ChestMeshShadow:MESH

Global Hip:BODY
Global HipMeshShadow:MESH

Global UpperArmLeft:BODY
Global UpperArmLeftMeshShadow:MESH

Global UpperArmRight:BODY
Global UpperArmRightMeshShadow:MESH

Global ForearmLeft:BODY
Global ForearmLeftMeshShadow:MESH

Global ForearmRight:BODY
Global ForearmRightMeshShadow:MESH

Global ThighLeft:BODY
Global ThighLeftMeshShadow:MESH

Global ThighRight:BODY
Global ThighRightMeshShadow:MESH

Global ShinLeft:BODY
Global ShinLeftMeshShadow:MESH

Global ShinRight:BODY
Global ShinRightMeshShadow:MESH

Global HeadTerrain:BODYBODY
Global ChestTerrain:BODYBODY
Global HipTerrain:BODYBODY
Global UpperArmLeftTerrain:BODYBODY
Global UpperArmRightTerrain:BODYBODY
Global ForearmLeftTerrain:BODYBODY
Global ForearmRightTerrain:BODYBODY
Global ThighLeftTerrain:BODYBODY
Global ThighRightTerrain:BODYBODY
Global ShinLeftTerrain:BODYBODY
Global ShinRightTerrain:BODYBODY

Global HeadBoneJoint:JOINT
Global ChestBoneJoint:JOINT
Global UpperArmLeftBoneJoint:JOINT
Global UpperArmRightBoneJoint:JOINT
Global ForearmLeftBoneJoint:JOINT
Global ForearmRightBoneJoint:JOINT
Global ThighLeftBoneJoint:JOINT
Global ThighRightBoneJoint:JOINT
Global ShinLeftBoneJoint:JOINT
Global ShinRightBoneJoint:JOINT

Global SkinMesh:SKINMESH

Global HeadBone:SKINMESHBONE
Global ChestBone:SKINMESHBONE
Global HipBone:SKINMESHBONE
Global UpperArmLeftBone:SKINMESHBONE
Global UpperArmRightBone:SKINMESHBONE
Global ForearmLeftBone:SKINMESHBONE
Global ForearmRightBone:SKINMESHBONE
Global ThighLeftBone:SKINMESHBONE
Global ThighRightBone:SKINMESHBONE
Global ShinLeftBone:SKINMESHBONE
Global ShinRightBone:SKINMESHBONE

Global HeadBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ChestBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global HipBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global UpperArmLeftBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global UpperArmRightBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ForearmLeftBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ForearmRightBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ThighLeftBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ThighRightBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ShinLeftBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()
Global ShinRightBoneLocation:D3DXVECTOR3=_D3DXVECTOR3()

Global HeadBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ChestBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global HipBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global UpperArmLeftBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global UpperArmRightBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ForearmLeftBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ForearmRightBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ThighLeftBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ThighRightBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ShinLeftBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()
Global ShinRightBoneOrientation:D3DXQUATERNION=_D3DXQUATERNION()

Const MAX_EFFECTS:Int = 18

' Define Global variables required by this demo
Global Effect:Byte Ptr[MAX_EFFECTS]
Global EnvMap:ENVMAP
Global NormalMap:TEXTURE
Global LightColor:D3DXVECTOR4 = _D3DXVECTOR4()
Global FontWhite:FONT

Global FogEffectEnable:Int 

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()

		Camera=iCameraCreate(0.0,0.0,1.0,1.0)
		iCameraLocationSet(Camera,_D3DXVECTOR3(0.0,1.0,-3.0))
	
		LightColor = _D3DXVECTOR4(1.0,1.0,1.0,0.35)
		iLightDirectionalSet(_D3DXVECTOR3(1.0,-1.0,1.0),LightColor)
	
		LoadingMessage=iSpriteCreate("default_res\\sprites\\loading.x",Null)
		iSpriteRender(LoadingMessage,False)
	
		SkyBox=iSkyBoxCreate("default_res\\skyboxes\\skybox01.sky")
		
		Terrain=iBodyCreate("default_res\\terrain_5.00.ply")
		TerrainMesh=iBodyMeshCreate("default_res\\terrain.x",Terrain)
		
		Local actorlocation:D3DXVECTOR3 = _D3DXVECTOR3(0.0,1.0,0.0)
		Local density:Float = 0.13
		Local ldamp:Float = 0.999
		Local adamp:Float = 0.97
		
		Head=iBodySGCreate("default_res\\ragdoll\\androHead_.spg",density)
		HeadMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androHead_shadow.x",Head,50.0)
		iBodyLocationSet(Head,actorlocation,True)
		iBodyDampingSet(Head,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(Head,100.0,0.05,3600.0,0.05)
		
		Chest=iBodySGCreate("default_res\\ragdoll\\androChest_.spg",density)
		ChestMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androChest_shadow.x",Chest,50.0)
		iBodyLocationSet(Chest,actorlocation,True)
		iBodyDampingSet(Chest,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(Chest,100.0,0.05,3600.0,0.05)
	
		Hip=iBodySGCreate("default_res\\ragdoll\\androHip_.spg",density)
		HipMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androHip_shadow.x",Hip,50.0)
		iBodyLocationSet(Hip,actorlocation,True)
		iBodyDampingSet(Hip,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(Hip,100.0,0.05,3600.0,0.05)

		UpperArmLeft=iBodySGCreate("default_res\\ragdoll\\androUpperArmLeft_.spg",density)
		UpperArmLeftMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androUpperArmLeft_shadow.x",UpperArmLeft,50.0)
		iBodyLocationSet(UpperArmLeft,actorlocation,True)
		iBodyDampingSet(UpperArmLeft,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(UpperArmLeft,100.0,0.05,3600.0,0.05)
		
		UpperArmRight=iBodySGCreate("default_res\\ragdoll\\androUpperArmRight_.spg",density)
		UpperArmRightMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androUpperArmRight_shadow.x",UpperArmRight,50.0)
		iBodyLocationSet(UpperArmRight,actorlocation,True)
		iBodyDampingSet(UpperArmRight,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(UpperArmRight,100.0,0.05,3600.0,0.05)
		
		ForearmLeft=iBodySGCreate("default_res\\ragdoll\\androForearmLeft_.spg",density)
		ForearmLeftMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androForearmLeft_shadow.x",ForearmLeft,50.0)
		iBodyLocationSet(ForearmLeft,actorlocation,True)
		iBodyDampingSet(ForearmLeft,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ForearmLeft,100.0,0.05,3600.0,0.05)
		
		ForearmRight=iBodySGCreate("default_res\\ragdoll\\androForearmRight_.spg",density)
		ForearmRightMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androForearmRight_shadow.x",ForearmRight,50.0)
		iBodyLocationSet(ForearmRight,actorlocation,True)
		iBodyDampingSet(ForearmRight,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ForearmRight,100.0,0.05,3600.0,0.05)
		
		ThighLeft=iBodySGCreate("default_res\\ragdoll\\androThighLeft_.spg",density)
		ThighLeftMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androThighLeft_shadow.x",ThighLeft,50.0)
		iBodyLocationSet(ThighLeft,actorlocation,True)
		iBodyDampingSet(ThighLeft,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ThighLeft,100.0,0.05,3600.0,0.05)
		
		ThighRight=iBodySGCreate("default_res\\ragdoll\\androThighRight_.spg",density)
		ThighRightMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androThighRight_shadow.x",ThighRight,50.0)
		iBodyLocationSet(ThighRight,actorlocation,True)
		iBodyDampingSet(ThighRight,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ThighRight,100.0,0.05,3600.0,0.05)
		
		ShinLeft=iBodySGCreate("default_res\\ragdoll\\androShinLeft_.spg",density)
		ShinLeftMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androShinLeft_shadow.x",ShinLeft,50.0)
		iBodyLocationSet(ShinLeft,actorlocation,True)
		iBodyDampingSet(ShinLeft,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ShinLeft,100.0,0.05,3600.0,0.05)
		
		ShinRight=iBodySGCreate("default_res\\ragdoll\\androShinRight_.spg",density)
		ShinRightMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ragdoll\\androShinRight_shadow.x",ShinRight,50.0)
		iBodyLocationSet(ShinRight,actorlocation,True)
		iBodyDampingSet(ShinRight,0.0,ldamp,0.0,adamp)
		iBodyDamping2Set(ShinRight,100.0,0.05,3600.0,0.05)
	
		FontWhite = iFontCreate("default_res\\fontwhite\\font.wid",Null)
		
		' create an environment map cube-texture For our shader tests
		EnvMap = iEnvMapCreate("default_res\\envmap.dds")
	
		' create a normal map texture For our shader tests
		NormalMap = iTextureCreate("default_res\\normalMap.tga")
	
		' Initialize effects array
		For Local i:Int=0 Until MAX_EFFECTS
			Effect[i] = Null
		Next
		
		' create all shader effects at startup so we can switch them run-time without affecting framerate
		Effect[0] = iSkinMeshEffectCreate("fxShaders\\pp_smooth.fx")
		Effect[1] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_glossy.fx")
		Effect[2] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_reflect.fx")
		Effect[3] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_glossy_reflect.fx")
		Effect[4] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy.fx")
		Effect[5] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_glossy.fx")
		Effect[6] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_reflect.fx")
		Effect[7] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_glossy_reflect.fx")
		Effect[8] = iSkinMeshEffectCreate("fxShaders\\default.fx")
		Effect[9] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_fog.fx")
		Effect[10] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_glossy_fog.fx")
		Effect[11] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_reflect_fog.fx")
		Effect[12] = iSkinMeshEffectCreate("fxShaders\\pp_smooth_glossy_reflect_fog.fx")
		Effect[13] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_fog.fx")
		Effect[14] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_glossy_fog.fx")
		Effect[15] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_reflect_fog.fx")
		Effect[16] = iSkinMeshEffectCreate("fxShaders\\pp_bumpy_glossy_reflect_fog.fx")
		Effect[17] = iSkinMeshEffectCreate("fxShaders\\default_fog.fx")

		' create the skinned mesh using a custom shader
		SkinMesh=iSkinMeshCreate("default_res\\ragdoll\\androrest.x","fxShaders\\pp_smooth.fx")
		iSkinMeshLocationSet(SkinMesh,actorlocation)
		iSkinMeshRenderModeSet(SkinMesh,D3DBLEND_SRCALPHA,D3DBLEND_INVSRCALPHA,True,True)
		
		' Disable Default material parameters, Not used by per-pixel shaders
		iSkinMeshEffectDefaultEnable(SkinMesh,True,False,True)
		
		' set no fog effect by Default
		FogEffectEnable = False

		HeadBone=iSkinMeshBoneCreateByName(SkinMesh,"HeadBone")
		ChestBone=iSkinMeshBoneCreateByName(SkinMesh,"ChestBone")
		HipBone=iSkinMeshBoneCreateByName(SkinMesh,"HipBone")
		UpperArmLeftBone=iSkinMeshBoneCreateByName(SkinMesh,"UpperArmLeftBone")
		UpperArmRightBone=iSkinMeshBoneCreateByName(SkinMesh,"UpperArmRightBone")
		ForearmLeftBone=iSkinMeshBoneCreateByName(SkinMesh,"ForearmLeftBone")
		ForearmRightBone=iSkinMeshBoneCreateByName(SkinMesh,"ForearmRightBone")
		ThighLeftBone=iSkinMeshBoneCreateByName(SkinMesh,"ThighLeftBone")
		ThighRightBone=iSkinMeshBoneCreateByName(SkinMesh,"ThighRightBone")
		ShinLeftBone=iSkinMeshBoneCreateByName(SkinMesh,"ShinLeftBone")
		ShinRightBone=iSkinMeshBoneCreateByName(SkinMesh,"ShinRightBone")
		
		iSkinMeshBoneLocation(HeadBone,HeadBoneLocation,0)
		iSkinMeshBoneLocation(ChestBone,ChestBoneLocation,0)
		iSkinMeshBoneLocation(UpperArmLeftBone,UpperArmLeftBoneLocation,0)
		iSkinMeshBoneLocation(UpperArmRightBone,UpperArmRightBoneLocation,0)
		iSkinMeshBoneLocation(ForearmLeftBone,ForearmLeftBoneLocation,0)
		iSkinMeshBoneLocation(ForearmRightBone,ForearmRightBoneLocation,0)
		iSkinMeshBoneLocation(ThighLeftBone,ThighLeftBoneLocation,0)
		iSkinMeshBoneLocation(ThighRightBone,ThighRightBoneLocation,0)
		iSkinMeshBoneLocation(ShinLeftBone,ShinLeftBoneLocation,0)
		iSkinMeshBoneLocation(ShinRightBone,ShinRightBoneLocation,0)
		
		iSkinMeshBoneOrientation(HeadBone,HeadBoneOrientation,0)
		iSkinMeshBoneOrientation(ChestBone,ChestBoneOrientation,0)
		iSkinMeshBoneOrientation(UpperArmLeftBone,UpperArmLeftBoneOrientation,0)
		iSkinMeshBoneOrientation(UpperArmRightBone,UpperArmRightBoneOrientation,0)
		iSkinMeshBoneOrientation(ForearmLeftBone,ForearmLeftBoneOrientation,0)
		iSkinMeshBoneOrientation(ForearmRightBone,ForearmRightBoneOrientation,0)
		iSkinMeshBoneOrientation(ThighLeftBone,ThighLeftBoneOrientation,0)
		iSkinMeshBoneOrientation(ThighRightBone,ThighRightBoneOrientation,0)
		iSkinMeshBoneOrientation(ShinLeftBone,ShinLeftBoneOrientation,0)
		iSkinMeshBoneOrientation(ShinRightBone,ShinRightBoneOrientation,0)

		HeadBoneJoint = iJointBallCreate(Chest,Head,HeadBoneLocation)
		ChestBoneJoint = iJointBallCreate(Hip,Chest,ChestBoneLocation)
		UpperArmLeftBoneJoint = iJointBallCreate(Chest,UpperArmLeft,UpperArmLeftBoneLocation)
		UpperArmRightBoneJoint = iJointBallCreate(Chest,UpperArmRight,UpperArmRightBoneLocation)
		ForearmLeftBoneJoint = iJointBallCreate(UpperArmLeft,ForearmLeft,ForearmLeftBoneLocation)
		ForearmRightBoneJoint = iJointBallCreate(UpperArmRight,ForearmRight,ForearmRightBoneLocation)
		ThighLeftBoneJoint = iJointBallCreate(Hip,ThighLeft,ThighLeftBoneLocation)
		ThighRightBoneJoint = iJointBallCreate(Hip,ThighRight,ThighRightBoneLocation)
		ShinLeftBoneJoint = iJointBallCreate(ThighLeft,ShinLeft,ShinLeftBoneLocation)
		ShinRightBoneJoint = iJointBallCreate(ThighRight,ShinRight,ShinRightBoneLocation)

		iJointBallOrientationSet(HeadBoneJoint,HeadBoneOrientation)
		iJointBallOrientationSet(ChestBoneJoint,ChestBoneOrientation)
		iJointBallOrientationSet(UpperArmLeftBoneJoint,UpperArmLeftBoneOrientation)
		iJointBallOrientationSet(UpperArmRightBoneJoint,UpperArmRightBoneOrientation)
		iJointBallOrientationSet(ForearmLeftBoneJoint,ForearmLeftBoneOrientation)
		iJointBallOrientationSet(ForearmRightBoneJoint,ForearmRightBoneOrientation)
		iJointBallOrientationSet(ThighLeftBoneJoint,ThighLeftBoneOrientation)
		iJointBallOrientationSet(ThighRightBoneJoint,ThighRightBoneOrientation)
		iJointBallOrientationSet(ShinLeftBoneJoint,ShinLeftBoneOrientation)
		iJointBallOrientationSet(ShinRightBoneJoint,ShinRightBoneOrientation)
		
		iJointBallXStopsSet(HeadBoneJoint,-35.0,35.0,25.0,1.0)
		iJointBallYStopsSet(HeadBoneJoint,-15.0,15.0,25.0,1.0)
		iJointBallZStopsSet(HeadBoneJoint,-20.0,20.0,25.0,1.0)
		iJointBallXAMotorSet(HeadBoneJoint,0.0,0.02,1.0)
		iJointBallYAMotorSet(HeadBoneJoint,0.0,0.02,1.0)
		iJointBallZAMotorSet(HeadBoneJoint,0.0,0.02,1.0)
		
		iJointBallXStopsSet(ChestBoneJoint,-15.0,15.0,25.0,1.0)
		iJointBallYStopsSet(ChestBoneJoint,-10.0,10.0,25.0,1.0)
		iJointBallZStopsSet(ChestBoneJoint,-5.0,5.0,25.0,1.0)
		iJointBallXAMotorSet(ChestBoneJoint,0.0,0.1,1.0)
		iJointBallYAMotorSet(ChestBoneJoint,0.0,0.1,1.0)
		iJointBallZAMotorSet(ChestBoneJoint,0.0,0.1,1.0)
		
		iJointBallXStopsSet(UpperArmLeftBoneJoint,-10.0,70.0,25.0,1.0)
		iJointBallYStopsSet(UpperArmLeftBoneJoint,-70.0,10.0,25.0,1.0)
		iJointBallZStopsSet(UpperArmLeftBoneJoint,-5.0,5.0,25.0,1.0)
		iJointBallXAMotorSet(UpperArmLeftBoneJoint,0.0,0.02,1.0)
		iJointBallYAMotorSet(UpperArmLeftBoneJoint,0.0,0.02,1.0)
		iJointBallZAMotorSet(UpperArmLeftBoneJoint,0.0,0.02,1.0)

		iJointBallXStopsSet(UpperArmRightBoneJoint,-10.0,70.0,25.0,1.0)
		iJointBallYStopsSet(UpperArmRightBoneJoint,-10.0,70.0,25.0,1.0)
		iJointBallZStopsSet(UpperArmRightBoneJoint,-5.0,5.0,25.0,1.0)
		iJointBallXAMotorSet(UpperArmRightBoneJoint,0.0,0.02,1.0)
		iJointBallYAMotorSet(UpperArmRightBoneJoint,0.0,0.02,1.0)
		iJointBallZAMotorSet(UpperArmRightBoneJoint,0.0,0.02,1.0)
		
		iJointBallXStopsSet(ForearmLeftBoneJoint,0.0,105.0,25.0,1.0)
		iJointBallYStopsSet(ForearmLeftBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallZStopsSet(ForearmLeftBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ForearmLeftBoneJoint,0.0,0.1,1.0)
		iJointBallYAMotorSet(ForearmLeftBoneJoint,0.0,0.1,1.0)
		iJointBallZAMotorSet(ForearmLeftBoneJoint,0.0,0.1,1.0)
		
		iJointBallXStopsSet(ForearmRightBoneJoint,0.0,105.0,25.0,1.0)
		iJointBallYStopsSet(ForearmRightBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallZStopsSet(ForearmRightBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ForearmRightBoneJoint,0.0,0.1,1.0)
		iJointBallYAMotorSet(ForearmRightBoneJoint,0.0,0.1,1.0)
		iJointBallZAMotorSet(ForearmRightBoneJoint,0.0,0.1,1.0)
		
		iJointBallXStopsSet(ThighLeftBoneJoint,-5.0,80.0,10.0,0.0)
		iJointBallYStopsSet(ThighLeftBoneJoint,0.0,40.0,25.0,1.0)
		iJointBallZStopsSet(ThighLeftBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ThighLeftBoneJoint,0.0,0.01,1.0)
		iJointBallYAMotorSet(ThighLeftBoneJoint,0.0,0.01,1.0)
		iJointBallZAMotorSet(ThighLeftBoneJoint,0.0,0.01,1.0)
		
		iJointBallXStopsSet(ThighRightBoneJoint,-5.0,80.0,10.0,0.0)
		iJointBallYStopsSet(ThighRightBoneJoint,-40.0,0.0,25.0,1.0)
		iJointBallZStopsSet(ThighRightBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ThighRightBoneJoint,0.0,0.01,1.0)
		iJointBallYAMotorSet(ThighRightBoneJoint,0.0,0.01,1.0)
		iJointBallZAMotorSet(ThighRightBoneJoint,0.0,0.01,1.0)

		iJointBallXStopsSet(ShinLeftBoneJoint,-105.0,0.0,5.0,0.0)
		iJointBallYStopsSet(ShinLeftBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallZStopsSet(ShinLeftBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ShinLeftBoneJoint,0.0,0.1,1.0)
		iJointBallYAMotorSet(ShinLeftBoneJoint,0.0,0.1,1.0)
		iJointBallZAMotorSet(ShinLeftBoneJoint,0.0,0.1,1.0)
		
		iJointBallXStopsSet(ShinRightBoneJoint,-105.0,0.0,5.0,0.0)
		iJointBallYStopsSet(ShinRightBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallZStopsSet(ShinRightBoneJoint,0.0,0.0,25.0,1.0)
		iJointBallXAMotorSet(ShinRightBoneJoint,0.0,0.1,1.0)
		iJointBallYAMotorSet(ShinRightBoneJoint,0.0,0.1,1.0)
		iJointBallZAMotorSet(ShinRightBoneJoint,0.0,0.1,1.0)

		HeadTerrain=iBodyBodyCreate(Head,Terrain)
		ChestTerrain=iBodyBodyCreate(Chest,Terrain)
		HipTerrain=iBodyBodyCreate(Hip,Terrain)
		UpperArmLeftTerrain=iBodyBodyCreate(UpperArmLeft,Terrain)
		UpperArmRightTerrain=iBodyBodyCreate(UpperArmRight,Terrain)
		ForearmLeftTerrain=iBodyBodyCreate(ForearmLeft,Terrain)
		ForearmRightTerrain=iBodyBodyCreate(ForearmRight,Terrain)
		ThighLeftTerrain=iBodyBodyCreate(ThighLeft,Terrain)
		ThighRightTerrain=iBodyBodyCreate(ThighRight,Terrain)
		ShinLeftTerrain=iBodyBodyCreate(ShinLeft,Terrain)
		ShinRightTerrain=iBodyBodyCreate(ShinRight,Terrain)

		Local friction:Float = 2.5
		iBodyBodyFrictionSet(HeadTerrain,friction)
		iBodyBodyFrictionSet(ChestTerrain,friction)
		iBodyBodyFrictionSet(HipTerrain,friction)
		iBodyBodyFrictionSet(UpperArmLeftTerrain,friction)
		iBodyBodyFrictionSet(UpperArmRightTerrain,friction)
		iBodyBodyFrictionSet(ForearmLeftTerrain,friction)
		iBodyBodyFrictionSet(ForearmRightTerrain,friction)
		iBodyBodyFrictionSet(ThighLeftTerrain,friction)
		iBodyBodyFrictionSet(ThighRightTerrain,friction)
		iBodyBodyFrictionSet(ShinLeftTerrain,friction)
		iBodyBodyFrictionSet(ShinRightTerrain,friction)
		
		iBodyEnable(Terrain)
		iBodyEnable(Head)
		iBodyEnable(Chest)
		iBodyEnable(Hip)
		iBodyEnable(UpperArmLeft)
		iBodyEnable(UpperArmRight)
		iBodyEnable(ForearmLeft)
		iBodyEnable(ForearmRight)
		iBodyEnable(ThighLeft)
		iBodyEnable(ThighRight)
		iBodyEnable(ShinLeft)
		iBodyEnable(ShinRight)
		
		iSpriteHide(LoadingMessage)
		iSkyBoxShow(SkyBox)
		iMeshShow(TerrainMesh)

		iMeshShow(HeadMeshShadow)
		iMeshShow(ChestMeshShadow)
		iMeshShow(HipMeshShadow)
		iMeshShow(UpperArmLeftMeshShadow)
		iMeshShow(UpperArmRightMeshShadow)
		iMeshShow(ForearmLeftMeshShadow)
		iMeshShow(ForearmRightMeshShadow)
		iMeshShow(ThighLeftMeshShadow)
		iMeshShow(ThighRightMeshShadow)
		iMeshShow(ShinLeftMeshShadow)
		iMeshShow(ShinRightMeshShadow)
		
		iSkinMeshShow(SkinMesh)

		Local sprite:SPRITE = iSpriteCreate("default_res\\sprites\\controls.x",Null)
		iSpriteLocationSet(sprite,_D3DXVECTOR2(0.0,-10.0))
		iSpriteShow(sprite)
	EndMethod
	
	Method _Run()

		Local cameratarget:D3DXVECTOR3=_D3DXVECTOR3()
		iBodyLocationCM(Hip,cameratarget)
		iCameraLookAt(Camera,cameratarget,0.1)
		
		Local location:D3DXVECTOR3=_D3DXVECTOR3()
		Local orientation:D3DXQUATERNION=_D3DXQUATERNION()

		iBodyLocation(Hip,location)
		iBodyOrientation(Hip,orientation)
		iSkinMeshOrientationSet(SkinMesh,orientation)
		iSkinMeshLocationSet(SkinMesh,location)
		
		iBodyOrientation(Chest,orientation)
		iQuaternionMultiply(orientation,orientation,ChestBoneOrientation)
		iSkinMeshBoneOrientationSet(ChestBone,orientation,0)
		
		iBodyOrientation(Head,orientation)
		iQuaternionMultiply(orientation,orientation,HeadBoneOrientation)
		iSkinMeshBoneOrientationSet(HeadBone,orientation,0)
		
		iBodyOrientation(UpperArmLeft,orientation)
		iQuaternionMultiply(orientation,orientation,UpperArmLeftBoneOrientation)
		iSkinMeshBoneOrientationSet(UpperArmLeftBone,orientation,0)
	
		iBodyOrientation(UpperArmRight,orientation)
		iQuaternionMultiply(orientation,orientation,UpperArmRightBoneOrientation)
		iSkinMeshBoneOrientationSet(UpperArmRightBone,orientation,0)
		
		iBodyOrientation(ForearmLeft,orientation)
		iQuaternionMultiply(orientation,orientation,ForearmLeftBoneOrientation)
		iSkinMeshBoneOrientationSet(ForearmLeftBone,orientation,0)
		
		iBodyOrientation(ForearmRight,orientation)
		iQuaternionMultiply(orientation,orientation,ForearmRightBoneOrientation)
		iSkinMeshBoneOrientationSet(ForearmRightBone,orientation,0)
		
		iBodyOrientation(ThighLeft,orientation)
		iQuaternionMultiply(orientation,orientation,ThighLeftBoneOrientation)
		iSkinMeshBoneOrientationSet(ThighLeftBone,orientation,0)
		
		iBodyOrientation(ThighRight,orientation)
		iQuaternionMultiply(orientation,orientation,ThighRightBoneOrientation)
		iSkinMeshBoneOrientationSet(ThighRightBone,orientation,0)
		
		iBodyOrientation(ShinLeft,orientation)
		iQuaternionMultiply(orientation,orientation,ShinLeftBoneOrientation)
		iSkinMeshBoneOrientationSet(ShinLeftBone,orientation,0)
		
		iBodyOrientation(ShinRight,orientation)
		iQuaternionMultiply(orientation,orientation,ShinRightBoneOrientation)
		iSkinMeshBoneOrientationSet(ShinRightBone,orientation,0)
		
		Local acceleration:D3DXVECTOR3=_D3DXVECTOR3()
		Local cameraorientation:D3DXQUATERNION=_D3DXQUATERNION()
	
		acceleration=_D3DXVECTOR3(0.0,0.0,0.0)
		If (iKeyDown(DIK_LEFT)) acceleration.PlusEq(_D3DXVECTOR3(-50.0,0.0,0.0))
		If (iKeyDown(DIK_RIGHT)) acceleration.PlusEq(_D3DXVECTOR3(50.0,0.0,0.0))
		If (iKeyDown(DIK_UP)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,50.0))
		If (iKeyDown(DIK_DOWN)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,-50.0))

		iCameraOrientation(Camera,cameraorientation)
		iVectorRotate(acceleration,acceleration,cameraorientation)
	
		iBodyAccelerationApply(Chest,acceleration)
	
		Local gravity:Float = 9.80665
		iBodyAccelerationApply(Head,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(Chest,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(Hip,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(UpperArmLeft,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(UpperArmRight,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ForearmLeft,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ForearmRight,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ThighLeft,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ThighRight,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ShinLeft,_D3DXVECTOR3(0.0,-gravity,0.0))
		iBodyAccelerationApply(ShinRight,_D3DXVECTOR3(0.0,-gravity,0.0))
		If (iKeyDown(DIK_LCONTROL) Or iKeyDown(DIK_RCONTROL)) iBodyAccelerationApply(Chest,_D3DXVECTOR3(0.0,gravity*12.0,0.0))
	
		' Let the user Select the shader effect To use
		Local fogEffectIndex:Int = -1
		If (iKeyClick(DIK_F1)) Then fogEffectIndex = 0
		If (iKeyClick(DIK_F2)) Then fogEffectIndex = 1
		If (iKeyClick(DIK_F3)) Then fogEffectIndex = 2
		If (iKeyClick(DIK_F4)) Then fogEffectIndex = 3
		If (iKeyClick(DIK_F5)) Then fogEffectIndex = 4
		If (iKeyClick(DIK_F6)) Then fogEffectIndex = 5
		If (iKeyClick(DIK_F7)) Then fogEffectIndex = 6
		If (iKeyClick(DIK_F8)) Then fogEffectIndex = 7
		If (iKeyClick(DIK_F9)) Then fogEffectIndex = 8
		If (iKeyClick(DIK_1)) Then fogEffectIndex = 9
		If (iKeyClick(DIK_2)) Then fogEffectIndex = 10
		If (iKeyClick(DIK_3)) Then fogEffectIndex = 11
		If (iKeyClick(DIK_4)) Then fogEffectIndex = 12
		If (iKeyClick(DIK_5)) Then fogEffectIndex = 13
		If (iKeyClick(DIK_6)) Then fogEffectIndex = 14
		If (iKeyClick(DIK_7)) Then fogEffectIndex = 15
		If (iKeyClick(DIK_8)) Then fogEffectIndex = 16
		If (iKeyClick(DIK_9)) Then fogEffectIndex = 17

		If (fogEffectIndex <> -1)
			iSkinMeshEffectSet(SkinMesh,Effect[fogEffectIndex])
			If (fogEffectIndex >= 9) Then
				FogEffectEnable = True
			Else 
				FogEffectEnable = False
			EndIf
		EndIf

		' Set shader-specific parameters. Note that Not all these parameters
		' are used by all the shaders we use in this demo.
		iSkinMeshEffectTextureSet(SkinMesh,"normalMap",NormalMap)
		iSkinMeshEffectEnvTextureSet(SkinMesh,"environmentMap",EnvMap.objptr)
		
		Local bumpScale:Float = 1.0
		iSkinMeshEffectValueSet(SkinMesh,"bumpScale",Varptr(bumpScale),4)
		Local ambient:Float = Max(Max(LightColor.x,LightColor.y),LightColor.z)*LightColor.w
		iSkinMeshEffectValueSet(SkinMesh,"ambient",Varptr(ambient),4)
		Local environmentMapBlend:Float = 0.25
		iSkinMeshEffectValueSet(SkinMesh,"environmentMapBlend",Varptr(environmentMapBlend),4)

		' If a shader supporting fog is used, post fog parameters
		If (FogEffectEnable)
			Local fogColor:D3DXVECTOR3 = _D3DXVECTOR3(0.0,0.0,1.0)
			Local fogStart:Float = 1.0
			Local fogEnd:Float = 5.0
			iSkinMeshEffectValueSet(SkinMesh,"fogColor",fogColor.param(),4)
			iSkinMeshEffectValueSet(SkinMesh,"fogStart",Varptr(fogStart),4)
			iSkinMeshEffectValueSet(SkinMesh,"fogEnd",Varptr(fogEnd),4)
		EndIf

		' Print controls message
		iPrintCentered("[F1]..[F9] to change shader, [1]..[9] to test blue fog effect",_D3DXVECTOR2(0.0,-11.6),_D3DXVECTOR2(0.5,0.5),0.1,FontWhite,0.0)
	EndMethod

	Method _exit()
		' Release all shader effects
		For Local i:Int=0 Until MAX_EFFECTS
		   If (Effect[i]) iSkinMeshEffectDestroy(Effect[i])
		Next
	EndMethod
EndType
