
Type JOINT Extends i3ImpactBase

	Method Destroy()
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method BallXStopsSet(lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallXStopsSet(objptr,lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
	EndMethod
	
	Method BallYStopsSet(lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallYStopsSet(objptr,lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
	EndMethod
	
	Method BallZStopsSet(lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallZStopsSet(objptr,lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
	EndMethod
	
	Method BallXAMotorSet(targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallXAMotorSet(objptr,targetSpin,torqueIntensity,fudgeFactor)
	EndMethod
	
	Method BallYAMotorSet(targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallYAMotorSet(objptr,targetSpin,torqueIntensity,fudgeFactor)
	EndMethod
	
	Method BallZAMotorSet(targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallZAMotorSet(objptr,targetSpin,torqueIntensity,fudgeFactor)
	EndMethod
	
	Method BallOrientationSet(orientation:D3DXQUATERNION)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallOrientationSet(objptr,orientation.param())
	EndMethod
	
	Method BallLocation(location:D3DXVECTOR3)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointBallLocation(objptr,location.param())
	EndMethod
	
	Method HingeStopsSet(lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointHingeStopsSet(objptr,lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
	EndMethod
	
	Method HingeAMotorSet(targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointHingeAMotorSet(objptr,targetSpin,torqueIntensity,fudgeFactor)
	EndMethod
	
	Method SliderStopsSet(lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointSliderStopsSet(objptr,lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
	EndMethod
	
	Method SliderForceSet(targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointSliderForceSet(objptr,targetSpin,torqueIntensity,fudgeFactor)
	EndMethod
	
	Method FeedbackEnable(bEnable:Int)
		If Not IsValid() RuntimeError "Invalid Joint"
		_iJointFeedbackEnable(objptr,bEnable)
	EndMethod
	
	Method Feedback(firstForce:D3DXVECTOR3,firstTorque:D3DXVECTOR3,secondForce:D3DXVECTOR3,secondTorque:D3DXVECTOR3)
		Local pFirstForce:Byte Ptr=Null
		Local pFirstTorque:Byte Ptr=Null
		Local pSecondForce:Byte Ptr=Null
		Local pSecondTorque:Byte Ptr=Null
			
		If firstForce<>Null Then pFirstForce=firstForce.param()
		If firstTorque<>Null Then pFirstTorque=firstTorque.param()
		If secondForce<>Null Then pSecondForce=secondForce.param()
		If secondTorque<>Null Then pSecondTorque=secondTorque.param()
			
		_iJointFeedback(objptr,pFirstForce,pFirstTorque,pSecondForce,pSecondTorque)
	EndMethod
EndType

Function iJointBallCreate:JOINT(firstBody:BODY,secondBody:BODY,joint:D3DXVECTOR3,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.JointBallCreate(firstBody,secondBody,joint,generateFunc)
EndFunction

Function iJointHingeCreate:JOINT(firstBody:BODY,secondBody:BODY,jointLocation:D3DXVECTOR3,jointDirection:D3DXVECTOR3,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.JointHingeCreate(firstBody,secondBody,jointLocation,jointDirection,generateFunc)
EndFunction

Function iJointSliderCreate:JOINT(firstBody:BODY,secondBody:BODY,jointDirection:D3DXVECTOR3,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.JointSliderCreate(firstBody,secondBody,jointDirection,generateFunc)
EndFunction

Function iJointDestroy(jnt:JOINT)
	If Not jnt RuntimeError "Joint is Null"
	jnt.Destroy()
EndFunction

Function iJointBallXStopsSet(jnt:JOINT,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallXStopsSet(lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
EndFunction

Function iJointBallYStopsSet(jnt:JOINT,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallYStopsSet(lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
EndFunction

Function iJointBallZStopsSet(jnt:JOINT,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallZStopsSet(lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
EndFunction

Function iJointBallXAMotorSet(jnt:JOINT,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallXAMotorSet(targetSpin,torqueIntensity,fudgeFactor)
EndFunction

Function iJointBallYAMotorSet(jnt:JOINT,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallYAMotorSet(targetSpin,torqueIntensity,fudgeFactor)
EndFunction

Function iJointBallZAMotorSet(jnt:JOINT,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallZAMotorSet(targetSpin,torqueIntensity,fudgeFactor)
EndFunction

Function iJointBallOrientationSet(jnt:JOINT,orientation:D3DXQUATERNION)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallOrientationSet(orientation)
EndFunction

Function iJointBallLocation(jnt:JOINT,location:D3DXVECTOR3)
	If Not jnt RuntimeError "Joint is Null"
	jnt.BallLocation(location)
EndFunction

Function iJointHingeStopsSet(jnt:JOINT,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.HingeStopsSet(lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
EndFunction

Function iJointHingeAMotorSet(jnt:JOINT,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.HingeAMotorSet(targetSpin,torqueIntensity,fudgeFactor)
EndFunction

Function iJointSliderStopsSet(jnt:JOINT,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.SliderStopsSet(lowerAngularLimit,higherAngularLimit,rotationalStopStrength,rotationalStopHardness)
EndFunction

Function iJointSliderForceSet(jnt:JOINT,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)
	If Not jnt RuntimeError "Joint is Null"
	jnt.SliderForceSet(targetSpin,torqueIntensity,fudgeFactor)
EndFunction

Function iJointFeedbackEnable(jnt:JOINT,bEnable:Int)
	If Not jnt RuntimeError "Joint is Null"
	jnt.FeedbackEnable(bEnable)
EndFunction

Function iJointFeedback(jnt:JOINT,firstForce:D3DXVECTOR3,firstTorque:D3DXVECTOR3,secondForce:D3DXVECTOR3,secondTorque:D3DXVECTOR3)
	If Not jnt RuntimeError "Joint is Null"
	jnt.Feedback(firstForce,firstTorque,secondForce,secondTorque)
EndFunction

Type WHEEL Extends i3ImpactBase

	Method Destroy()
		_iWheelDestroy(objptr)
		objptr=Null
	EndMethod 
	
	Method SteeringAngleSet(steeringAngle:Float)
		_iWheelSteeringAngleSet(objptr,steeringAngle)
	EndMethod 
	
	Method SpinSet(targetSpin:Float)
		_iWheelSpinSet(objptr,targetSpin)
	EndMethod 
	
	Method PowerSet(wheelPower:Float)
		_iWheelPowerSet(objptr,wheelPower)
	EndMethod 
	
	Method SuspensionSet(springFactor:Float,dampingFactor:Float)
		_iWheelSuspensionSet(objptr,springFactor,dampingFactor)
	EndMethod 

EndType

Function iWheelCreate:WHEEL(mainBody:BODY,wheel:BODY,mainBodyLocation:D3DXVECTOR3,wheelOrientation:D3DXQUATERNION,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.WheelCreate(mainBody,wheel,mainBodyLocation,wheelOrientation,generateFunc)
EndFunction

Function iWheelDestroy(whl:WHEEL)
	whl.Destroy()
EndFunction

Function iWheelSteeringAngleSet(whl:WHEEL,steeringAngle:Float)
	whl.SteeringAngleSet(steeringAngle)
EndFunction

Function iWheelSpinSet(whl:WHEEL,targetSpin:Float)
	whl.SpinSet(targetSpin)
EndFunction

Function iWheelPowerSet(whl:WHEEL,wheelPower:Float)
	whl.PowerSet(wheelPower)
EndFunction

Function iWheelSuspensionSet(whl:WHEEL,springFactor:Float,dampingFactor:Float)
	whl.SuspensionSet(springFactor,dampingFactor)
EndFunction

Extern
	
	' JOINTS
	Function _iJointBallCreate:Byte Ptr(BODY_firstBody:Byte Ptr,BODY_secondBody:Byte Ptr,D3DXVECTOR3_joint:Byte Ptr)="iJointBallCreate" ' returns JOINT*
	Function _iJointHingeCreate:Byte Ptr(BODY_firstBody:Byte Ptr,BODY_secondBody:Byte Ptr,D3DXVECTOR3_jointLocation:Byte Ptr,D3DXVECTOR3_jointDirection:Byte Ptr)="iJointHingeCreate" ' returns JOINT*
	Function _iJointSliderCreate:Byte Ptr(BODY_firstBody:Byte Ptr,BODY_secondBody:Byte Ptr,D3DXVECTOR3_jointDirection:Byte Ptr)="iJointSliderCreate" ' returns JOINT*
	Function _iJointDestroy(JOINT:Byte Ptr)="iJointDestroy"
	Function _iJointBallXStopsSet(JOINT:Byte Ptr,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)="iJointBallXStopsSet"
	Function _iJointBallYStopsSet(JOINT:Byte Ptr,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)="iJointBallYStopsSet"
	Function _iJointBallZStopsSet(JOINT:Byte Ptr,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)="iJointBallZStopsSet"
	Function _iJointBallXAMotorSet(JOINT:Byte Ptr,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)="iJointBallXAMotorSet"
	Function _iJointBallYAMotorSet(JOINT:Byte Ptr,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)="iJointBallYAMotorSet"
	Function _iJointBallZAMotorSet(JOINT:Byte Ptr,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)="iJointBallZAMotorSet"
	Function _iJointBallOrientationSet(JOINT:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iJointBallOrientationSet"
	Function _iJointBallLocation(JOINT:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iJointBallLocation"
	Function _iJointHingeStopsSet(JOINT:Byte Ptr,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)="iJointHingeStopsSet"
	Function _iJointHingeAMotorSet(JOINT:Byte Ptr,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)="iJointHingeAMotorSet"
	Function _iJointSliderStopsSet(JOINT:Byte Ptr,lowerAngularLimit:Float,higherAngularLimit:Float,rotationalStopStrength:Float,rotationalStopHardness:Float)="iJointSliderStopsSet"
	Function _iJointSliderForceSet(JOINT:Byte Ptr,targetSpin:Float,torqueIntensity:Float,fudgeFactor:Float)="iJointSliderForceSet"
	Function _iJointFeedbackEnable(JOINT:Byte Ptr,bEnable:Int)="iJointFeedbackEnable"
	Function _iJointFeedback(JOINT:Byte Ptr,D3DXVECTOR3_firstForce:Byte Ptr,D3DXVECTOR3_firstTorque:Byte Ptr,D3DXVECTOR3_secondForce:Byte Ptr,D3DXVECTOR3_secondTorque:Byte Ptr)="iJointFeedback"
	Function _iWheelCreate:Byte Ptr(BODY_main:Byte Ptr,BODY_wheel:Byte Ptr,D3DXVECTOR3_mainBodyLocation:Byte Ptr,D3DXQUATERNION_wheelOrientation:Byte Ptr)="iWheelCreate" ' returns WHEEL* 
	Function _iWheelDestroy(WHEEL:Byte Ptr)="iWheelDestroy"
	Function _iWheelSteeringAngleSet(WHEEL:Byte Ptr,steeringAngle:Float)="iWheelSteeringAngleSet"
	Function _iWheelSpinSet(WHEEL:Byte Ptr,targetSpin:Float)="iWheelSpinSet"
	Function _iWheelPowerSet(WHEEL:Byte Ptr,wheelPower:Float)="iWheelPowerSet"
	Function _iWheelSuspensionSet(WHEEL:Byte Ptr,springFactor:Float,dampingFactor:Float)="iWheelSuspensionSet"
	
EndExtern
