

Type SPRITE Extends i3ImpactBase	
	
	Method Destroy()
		_iSpriteDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method Hide()
		_iSpriteHide(objptr)
	EndMethod
	
	Method Show()
		_iSpriteShow(objptr)
	EndMethod
	
	Method Set(location:D3DXVECTOR2,orientationAngle:Float,scaling:D3DXVECTOR2)
		_iSpriteSet(objptr,location.param(),orientationAngle,scaling.param())
	EndMethod
	
	Method OrientationSet(orientationAngle:Float)
		_iSpriteOrientationSet(objptr,orientationAngle)
	EndMethod
	
	Method LocationSet(location:D3DXVECTOR2)
		_iSpriteLocationSet(objptr,location.param())
	EndMethod
	
	Method Location(location:D3DXVECTOR2)
		_iSpriteLocation(objptr,location.param())
	EndMethod
	
	Method ScaleSet(scaling:D3DXVECTOR2)
		_iSpriteScaleSet(objptr,scaling.param())
	EndMethod
	
	Method PrioritySet(priority:Int)
		_iSpritePrioritySet(objptr,priority)
	EndMethod
	
	Method RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int)
		_iSpriteRenderModeSet(objptr,D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor)
	EndMethod
	
	Method ColorSet(red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)
		_iSpriteColorSet(objptr,red,green,blue,alpha)
	EndMethod
	
	Method TextureSet(tex:TEXTURE)
		_iSpriteTextureSet(objptr,tex.objptr)
	EndMethod
	
	Method TextureReset()
		_iSpriteTextureReset(objptr)
	EndMethod
	
	Method TextureSwap(tex:TEXTURE)
		_iSpriteTextureSwap(objptr,tex.objptr)
	EndMethod
	
	Method TextureChange(texture_filename:String)
		_iSpriteTextureChange(objptr,texture_filename)
	EndMethod
	
	Method AlphaTextureChange(texture_filename:String)
		_iSpriteAlphaTextureChange(objptr,texture_filename)
	EndMethod
	
	Method MipFilterModeSet(mipmapFilterMode:Int)
		_iSpriteMipFilterModeSet(objptr,mipmapFilterMode)
	EndMethod
	
	Method TextureModeSet(textureMappingMode:Int)
		_iSpriteTextureModeSet(objptr,textureMappingMode)
	EndMethod
	
	Method Picked:Int()
		Return _iSpritePicked(objptr)
	EndMethod
	
	Method Render(bWipeScreenBeforeRender:Int)
		_iSpriteRender(objptr,bWipeScreenBeforeRender)
	EndMethod

	Method RenderPrioritySet(priority:Int)
		_iSpriteRenderPrioritySet(objptr,priority)
	EndMethod

	Method CameraSet(camera:CAMERA)
		_iSpriteCameraSet(objptr,camera.objptr)
	EndMethod
EndType

Function iSpriteCreate:SPRITE(x_filename:String,cam:CAMERA,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SpriteCreate(x_filename,cam,generateFunc) 
EndFunction

Function iSpriteCreateFromMemory:SPRITE(x_filemem_ptr:Byte Ptr,x_memsize:Int,texture_filemem_ptr:Byte Ptr,texture_memsize:Int,textureID:Int,cam:CAMERA,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SpriteCreateFromMemory(x_filemem_ptr,x_memsize,texture_filemem_ptr,texture_memsize,textureID,cam,generateFunc) 
EndFunction

Function iSpriteDestroy(spr:SPRITE)
	spr.Destroy()
EndFunction

Function iSpriteHide(spr:SPRITE)
	spr.Hide()
EndFunction

Function iSpriteShow(spr:SPRITE)
	spr.Show()
EndFunction

Function iSpriteSet(spr:SPRITE,location:D3DXVECTOR2,orientationAngle:Float,scaling:D3DXVECTOR2)
	spr.Set(location,orientationAngle,scaling)
EndFunction

Function iSpriteOrientationSet(spr:SPRITE,orientationAngle:Float)
	spr.OrientationSet(orientationAngle)
EndFunction

Function iSpriteLocationSet(spr:SPRITE,location:D3DXVECTOR2)
	spr.LocationSet(location)
EndFunction

Function iSpriteLocation(spr:SPRITE,location:D3DXVECTOR2)
	spr.Location(location)
EndFunction

Function iSpriteScaleSet(spr:SPRITE,scaling:D3DXVECTOR2)
	spr.ScaleSet(scaling)
EndFunction

Function iSpritePrioritySet(spr:SPRITE,priority:Int)
	spr.PrioritySet(priority)
EndFunction

Function iSpriteRenderModeSet(spr:SPRITE,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int)
	spr.RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor)
EndFunction

Function iSpriteColorSet(spr:SPRITE,red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)
	spr.ColorSet(red,green,blue,alpha)
EndFunction

Function iSpriteTextureSet(spr:SPRITE,tex:TEXTURE)
	spr.TextureSet(tex)
EndFunction

Function iSpriteTextureReset(spr:SPRITE)
	spr.TextureReset()
EndFunction

Function iSpriteTextureSwap(spr:SPRITE,tex:TEXTURE)
	spr.TextureSwap(tex)
EndFunction

Function iSpriteTextureChange(spr:SPRITE,texture_filename:String)
	spr.TextureChange(texture_filename)
EndFunction

Function iSpriteAlphaTextureChange(spr:SPRITE,texture_filename:String)
	spr.AlphaTextureChange(texture_filename)
EndFunction

Function iSpriteMipFilterModeSet(spr:SPRITE,mipmapFilterMode:Int)
	spr.MipFilterModeSet(mipmapFilterMode)
EndFunction

Function iSpriteTextureModeSet(spr:SPRITE,textureMappingMode:Int)
	spr.TextureModeSet(textureMappingMode)
EndFunction

Function iSpritePicked:Int(spr:SPRITE)
	Return spr.Picked()
EndFunction

Function iSpriteRender(spr:SPRITE,bWipeScreenBeforeRender:Int)
	spr.Render(bWipeScreenBeforeRender)
EndFunction

Function iSpriteRenderPrioritySet(spr:SPRITE,priority:Int)
	spr.RenderPrioritySet(priority)
EndFunction

Function iSpriteCameraSet(spr:SPRITE, camera:CAMERA)
	spr.CameraSet(camera)
EndFunction

Extern
	' SPRITE
	Function _iSpriteCreate:Byte Ptr(x_filename$z,CAMERA:Byte Ptr)="iSpriteCreate" ' returns SPRITE* 
	Function _iSpriteCreateFromMemory:Byte Ptr(x_filemem_ptr:Byte Ptr,x_memsize:Int,texture_filemem_ptr:Byte Ptr,texture_memsize:Int,textureID:Int,CAMERA:Byte Ptr)="iSpriteCreateFromMemory" ' returns SPRITE* 
	
	Function _iSpriteDestroy(SPRITE:Byte Ptr)="iSpriteDestroy"
	Function _iSpriteHide(SPRITE:Byte Ptr)="iSpriteHide"
	Function _iSpriteShow(SPRITE:Byte Ptr)="iSpriteShow"
	Function _iSpriteSet(SPRITE:Byte Ptr,D3DXVECTOR2_location:Byte Ptr,orientationAngle:Float,D3DXVECTOR2_scaling:Byte Ptr)="iSpriteSet"
	Function _iSpriteOrientationSet(SPRITE:Byte Ptr,orientationAngle:Float)="iSpriteOrientationSet"
	Function _iSpriteLocationSet(SPRITE:Byte Ptr,D3DXVECTOR2_location:Byte Ptr)="iSpriteLocationSet"
	Function _iSpriteLocation(SPRITE:Byte Ptr,D3DXVECTOR2_location:Byte Ptr)="iSpriteLocation"
	Function _iSpriteScaleSet(SPRITE:Byte Ptr,D3DXVECTOR2_scaling:Byte Ptr)="iSpriteScaleSet"
	Function _iSpritePrioritySet(SPRITE:Byte Ptr,priority:Int)="iSpritePrioritySet"
	Function _iSpriteRenderModeSet(SPRITE:Byte Ptr,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int)="iSpriteRenderModeSet"
	Function _iSpriteColorSet(SPRITE:Byte Ptr,red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)="iSpriteColorSet"
	Function _iSpriteTextureSet(SPRITE:Byte Ptr,TEXTURE:Byte Ptr)="iSpriteTextureSet"
	Function _iSpriteTextureReset(SPRITE:Byte Ptr)="iSpriteTextureReset"
	Function _iSpriteTextureSwap(SPRITE:Byte Ptr,TEXTURE:Byte Ptr)="iSpriteTextureSwap"
	Function _iSpriteTextureChange(SPRITE:Byte Ptr,texture_filename$z)="iSpriteTextureChange"
	Function _iSpriteAlphaTextureChange(SPRITE:Byte Ptr,texture_filename$z)="iSpriteAlphaTextureChange"
	Function _iSpriteMipFilterModeSet(SPRITE:Byte Ptr,mipmapFilterMode:Int)="iSpriteMipFilterModeSet"
	Function _iSpriteTextureModeSet(SPRITE:Byte Ptr,textureMappingMode:Int)="iSpriteTextureModeSet"
	Function _iSpritePicked:Int(SPRITE:Byte Ptr)="iSpritePicked" ' returns true/false
	Function _iSpriteRender(SPRITE:Byte Ptr,bWipeScreenBeforeRender:Int)="iSpriteRender"
	Function _iSpriteRenderPrioritySet(SPRITE:Byte Ptr,priority:Int)="iSpriteRenderPrioritySet"	
	Function _iSpriteCameraSet(SPRITE:Byte Ptr,CAMERA:Byte Ptr) = "iSpriteCameraSet"
	
EndExtern
