Type ISETTINGS
	Field dwAdapter:Int=0
	Field dwDevice:Int=0
	Field dwMode:Int
	Field MultiSampleType:Int=0
	Field bFullScreen:Int
	Field bDoNotShow:Int
	Field bVSync:Int 
	
	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.dwAdapter))
	EndMethod
EndType

Function _ISETTINGS:ISETTINGS(width:Int,height:Int,depth:Int,bFullScreen:Int,bDoNotShowStartupDialog:Int, bVSync:Int)
	Local temp:ISETTINGS=New ISETTINGS
	temp.dwMode=(width*height*depth)
	temp.bFullScreen=bFullScreen
	temp.bDoNotShow=bDoNotShowStartupDialog
	temp.bVSync = bVSync
	Return temp
EndFunction

Type D3DXQUATERNION
	Field x:Float=0
	Field y:Float=0
	Field z:Float=0
	Field w:Float=1.0
	
	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.x))
	EndMethod
EndType

Function _D3DXQUATERNION:D3DXQUATERNION(x:Float=0,y:Float=0,z:Float=0,w:Float=1.0)
	Return _g_3IEngine._D3DXQUATERNION(x,y,z,w)
EndFunction

Type D3DXPLANE
	Field a:Float
	Field b:Float
	Field c:Float
	Field d:Float
	
	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.a))
	EndMethod
EndType

Function _D3DXPLANE:D3DXPLANE(a:Float,b:Float,c:Float,d:Float)
	Return _g_3IEngine._D3DXPLANE(a,b,c,d)
EndFunction

Type D3DXVECTOR2
	Field x:Float=0
	Field y:Float=0

	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.x))
	EndMethod

	' operator overloads
	Method PlusEq:D3DXVECTOR2(v:D3DXVECTOR2)
	   x :+ v.x
	   y :+ v.y
	   Return Self
	EndMethod

	Method MinusEq:D3DXVECTOR2(v:D3DXVECTOR2)
	   x :- v.x
	   y :- v.y
	   Return Self
	EndMethod

	Method MultEq:D3DXVECTOR2(f:Float)
	   x :* f
	   y :* f
	   Return Self
	EndMethod

	Method DivEq:D3DXVECTOR2(f:Float)
	   Local fInv:Float = 1.0/f
	   x :* fInv
	   y :* fInv
	   Return Self
	EndMethod

	Method Pos:D3DXVECTOR2()
	   Return Self
	EndMethod

	Method Neg:D3DXVECTOR2()
	   Return _D3DXVECTOR2(-x,-y)
	EndMethod
	
	Method Plus:D3DXVECTOR2(v:D3DXVECTOR2)
	   Return _D3DXVECTOR2(x+v.x,y+v.y)
	EndMethod

	Method Minus:D3DXVECTOR2(v:D3DXVECTOR2)
	   Return _D3DXVECTOR2(x-v.x,y-v.y)
	EndMethod
	
	Method Mult:D3DXVECTOR2(f:Float)
	   Return _D3DXVECTOR2(x*f,y*f)
	EndMethod
	
	Method Div:D3DXVECTOR2(f:Float)
	   Local fInv:Float = 1.0/f
	   Return _D3DXVECTOR2(x*fInv,y*fInv)
	EndMethod
	
	Method EqEq:Int(v:D3DXVECTOR2)
	   Return (x=v.x And y=v.y)
	EndMethod

	Method NotEq(v:D3DXVECTOR2)
	   Return Not EqEq(v)
	EndMethod
EndType

Function _D3DXVECTOR2:D3DXVECTOR2(x:Float=0,y:Float=0)
	Return _g_3IEngine._D3DXVECTOR2(x,y)
EndFunction

Type D3DXVECTOR3
	Field x:Float=0
	Field y:Float=0
	Field z:Float=0

	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.x))
	EndMethod
	
	' operator overloads
			
	Method Pos:D3DXVECTOR3()
	   Return Self
	EndMethod
	
	Method Neg:D3DXVECTOR3()
	   Return _D3DXVECTOR3(-x,-y,-z)
	EndMethod
	
	Method PlusEq:D3DXVECTOR3(v:D3DXVECTOR3)
		Self.x :+ v.x
		Self.y :+ v.y
		Self.z :+ v.z
		Return Self
	EndMethod	
	
	Method MinusEq:D3DXVECTOR3(v:D3DXVECTOR3)
		Self.x :- v.x
		Self.y :- v.y
		Self.z :- v.z
		Return Self
	EndMethod	

	Method MultEq:D3DXVECTOR3(f:Float)
	   x :* f
	   y :* f
	   z :* f
	   Return Self
	EndMethod
	
	Method DivEq:D3DXVECTOR3(f:Float)
	   Local fInv:Float = 1.0/f
	   x :* fInv
	   y :* fInv
	   z :* fInv
	   Return Self
	EndMethod
	
	Method Plus:D3DXVECTOR3(v:D3DXVECTOR3)
	   Return _D3DXVECTOR3(x+v.x,y+v.y,z+v.z)
	EndMethod
	
	Method Minus:D3DXVECTOR3(v:D3DXVECTOR3)
	   Return _D3DXVECTOR3(x-v.x,y-v.y,z-v.z)
	EndMethod
	
	Method Mult:D3DXVECTOR3(f:Float)
	   Return _D3DXVECTOR3(x*f,y*f,z*f)
	EndMethod

	Method Div:D3DXVECTOR3(f:Float)
	   Local fInv:Float = 1.0/f
	   Return _D3DXVECTOR3(x*fInv,y*fInv,z*fInv)
	EndMethod
	
	Method EqEq:Int(v:D3DXVECTOR3)
	   Return x=v.x And y=v.y And z=v.z
	EndMethod
	
	Method NotEq:Int(v:D3DXVECTOR3)
		Return Not EqEq(v)
	EndMethod
EndType

Function _D3DXVECTOR3:D3DXVECTOR3(x:Float=0,y:Float=0,z:Float=0)
	Return _g_3IEngine._D3DXVECTOR3(x,y,z)
EndFunction

Type D3DXVECTOR4
	Field x:Float=0
	Field y:Float=0
	Field z:Float=0
	Field w:Float=0
	
	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self.x))
	EndMethod

	Method PlusEq:D3DXVECTOR4(v:D3DXVECTOR4)
	   x :+ v.x
	   y :+ v.y
	   z :+ v.z
	   w :+ v.w
	   Return Self
	EndMethod
	
	Method MinusEq:D3DXVECTOR4(v:D3DXVECTOR4)
	   x :- v.x
	   y :- v.y
	   z :- v.z
	   w :- v.w
	   Return Self
	EndMethod

	Method MultEq:D3DXVECTOR4(f:Float)
	   x :* f
	   y :* f
	   z :* f
	   w :* f
	   Return Self
	EndMethod
	
	Method DivEq:D3DXVECTOR4(f:Float)
	   Local fInv:Float = 1.0/f
	   x :* fInv
	   y :* fInv
	   z :* fInv
	   w :* fInv
	   Return Self
	EndMethod
	
	Method Pos:D3DXVECTOR4()
	   Return Self
	EndMethod
	
	Method Neg:D3DXVECTOR4()
	   Return _D3DXVECTOR4(-x,-y,-z,-w)
	EndMethod
	
	Method Plus:D3DXVECTOR4(v:D3DXVECTOR4)
	   Return _D3DXVECTOR4(x+v.x,y+v.y,z+v.z,w+v.w)
	EndMethod
	
	Method Minus:D3DXVECTOR4(v:D3DXVECTOR4)
	   Return _D3DXVECTOR4(x-v.x,y-v.y,z-v.z,w-v.w)
	EndMethod
	
	Method Mult:D3DXVECTOR4(f:Float)
	   Return _D3DXVECTOR4(x*f,y*f,z*f,w*f)
	EndMethod
	
	Method Div:D3DXVECTOR4(f:Float)
	   Local fInv:Float = 1.0/f
	   Return _D3DXVECTOR4(x*fInv,y*fInv,z*fInv,w*fInv)
	EndMethod
	
	Method EqEq:Int(v:D3DXVECTOR4)
	   Return (x=v.x And y=v.y And z=v.z And w=v.w)
	EndMethod 
	
	Method NotEq:Int(v:D3DXVECTOR4)
	   Return Not EqEq(v)
	EndMethod
	
EndType

Function _D3DXVECTOR4:D3DXVECTOR4(x:Float=0,y:Float=0,z:Float=0,w:Float=0)
	Return _g_3IEngine._D3DXVECTOR4(x,y,z,w)
EndFunction

Type D3DXMATRIX
	Field _11:Float
	Field _12:Float
	Field _13:Float
	Field _14:Float
	Field _21:Float
	Field _22:Float
	Field _23:Float
	Field _24:Float
	Field _31:Float
	Field _32:Float
	Field _33:Float
	Field _34:Float
	Field _41:Float
	Field _42:Float
	Field _43:Float
	Field _44:Float

	Method param:Byte Ptr()
		Return Byte Ptr(Varptr(Self._11))
	EndMethod
EndType

Function _D3DXMATRIX:D3DXMATRIX(matrix:Float[])
	Return _g_3IEngine._D3DXMATRIX(matrix)
EndFunction