
' TEXTURE
Type TEXTURE Extends i3ImpactBase	

	Method Destroy()
		_iTextureDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method ToNormalMap()
		_iTextureToNormalMap(objptr)
	EndMethod
	
	Function MipLevelsSet(mipmapLevels:Int)
		_iTextureMipLevelsSet(mipmapLevels)
	EndFunction
	
	Function MipFilterSet(mipmapCreationAlgorithm:Int)
		_iTextureMipFilterSet(mipmapCreationAlgorithm)
	EndFunction
	
EndType

Function iTextureCreate:TEXTURE(img_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.TextureCreate(img_filename,generateFunc) 
EndFunction

Function iTextureCreateFromMemory:TEXTURE(img_memfile_ptr:Byte Ptr,img_memsize:Int,id:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.TextureCreateFromMemory(img_memfile_ptr,img_memsize,id,generateFunc) 
EndFunction

Function iTextureDestroy(tex:TEXTURE)
	tex.Destroy()
EndFunction

Function iTextureToNormalMap(tex:TEXTURE)
	tex.ToNormalMap()
EndFunction

Function iTextureMipLevelsSet(mipmapLevels:Int)
	TEXTURE.MipLevelsSet(mipmapLevels)
EndFunction

Function iTextureMipFilterSet(mipmapCreationAlgorithm:Int)
	TEXTURE.MipFilterSet(mipmapCreationAlgorithm)
EndFunction

Extern
	' TEXTURES
	Function _iTextureCreate:Byte Ptr(img_filename$z)="iTextureCreate" ' returns TEXTURE*
	Function _iTextureCreateFromMemory:Byte Ptr(img_memfile_ptr:Byte Ptr,img_memsize:Int,id:Int)="iTextureCreateFromMemory" ' returns TEXTURE*
	
	Function _iTextureDestroy(TEXTURE:Byte Ptr)="iTextureDestroy"
	Function _iTextureToNormalMap(TEXTURE:Byte Ptr)="iTextureToNormalMap"
	Function _iTextureMipLevelsSet(mipmapLevels:Int)="iTextureMipLevelsSet"
	Function _iTextureMipFilterSet(mipmapCreationAlgorithm:Int)="iTextureMipFilterSet"
EndExtern
