' TRAIL
' 2006/3/2 GG - added support for v4.2.0 iTrailTextureSet() and iTrailTextureReset()

Type TRAIL Extends i3ImpactBase	

	Method Destroy()
		_iTrailDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method Hide()
		_iTrailHide(objptr)
	EndMethod
	
	Method Show()
		_iTrailShow(objptr)
	EndMethod
	
	Method RenderModeSet(renderMode:Int)
		_iTrailRenderModeSet(objptr,renderMode)
	EndMethod
	
	Method LifeTimeSet(lifetime:Float)
		_iTrailLifeTimeSet(objptr,lifetime)
	EndMethod
	
	Method ColorSet(initialRGB:D3DXVECTOR3,finalRGB:D3DXVECTOR3)
		_iTrailColorSet(objptr,initialRGB.param(),finalRGB.param())
	EndMethod
	
	Method Reset()
		_iTrailReset(objptr)
	EndMethod

	Method TextureSet(tex:TEXTURE)
		_iTrailTextureSet(objptr,tex.objptr)
	EndMethod
	
	Method TextureReset()
		_iTrailTextureReset(objptr)
	EndMethod
	
	Method EnvMapCasterAdd()
		_iTrailEnvMapCasterAdd(objptr)
	EndMethod
	
	Method EnvMapCasterRemove()
		_iTrailEnvMapCasterRemove(objptr)
	EndMethod

	Method EmitterCreate:TRAILEMITTER(generateFunc:Byte Ptr=Null)
		Local retval:TRAILEMITTER
		If generateFunc<>Null
			Local genFunc:TRAILEMITTER()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateTrailEmitter()
		EndIf
		retval.objptr=_iTrailEmitterCreate(objptr)
		If retval.objptr<>Null Then Return retval Else Return Null				
	EndMethod
		
EndType

Function iTrailCreate:TRAIL(img_filename:String,maxSegments:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.TrailCreate(img_filename,maxSegments,generateFunc) 
EndFunction

Function iTrailCreateFromMemory:TRAIL(img_memfile_ptr:Byte Ptr,img_memsize:Int,textureID:Int,maxParticles:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.TrailCreateFromMemory(img_memfile_ptr,img_memsize,textureID,maxParticles,generateFunc) 
EndFunction

Function iTrailDestroy(trl:TRAIL)
	trl.Destroy()
EndFunction

Function iTrailHide(trl:TRAIL)
	trl.Hide()
EndFunction

Function iTrailShow(trl:TRAIL)
	trl.Show()
EndFunction

Function iTrailRenderModeSet(trl:TRAIL,renderMode:Int)
	trl.RenderModeSet(renderMode)
EndFunction

Function iTrailLifeTimeSet(trl:TRAIL,lifetime:Float)
	trl.LifeTimeSet(lifetime)
EndFunction

Function iTrailColorSet(trl:TRAIL,initialRGB:D3DXVECTOR3,finalRGB:D3DXVECTOR3)
	trl.ColorSet(initialRGB,finalRGB)
EndFunction

Function iTrailReset(trl:TRAIL)
	trl.Reset()
EndFunction

Function iTrailTextureSet(trl:TRAIL,tex:TEXTURE)
	trl.TextureSet(tex)
EndFunction

Function iTrailTextureReset(trl:TRAIL)
	trl.TextureReset()
EndFunction

Function iTrailEnvMapCasterAdd(trl:TRAIL)
	trl.EnvMapCasterAdd()
EndFunction

Function iTrailEnvMapCasterRemove(trl:TRAIL)
	trl.EnvMapCasterRemove()
EndFunction

Function iTrailEmitterCreate:TRAILEMITTER(trl:TRAIL,generateFunc:Byte Ptr=Null)
	Return trl.EmitterCreate(generateFunc)
EndFunction

Type TRAILEMITTER Extends i3ImpactBase	
	Method Destroy()
		_iTrailEmitterDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method Emit(particlesPerSecond:Float,initialAlphaIntensity:Float)
		_iTrailEmitterEmit(objptr,particlesPerSecond,initialAlphaIntensity)
	EndMethod
	
	Method LocationSet(location:D3DXVECTOR3)
		_iTrailEmitterLocationSet(objptr,location.param())
	EndMethod
	
	Method OrientationSet(orientation:D3DXQUATERNION)
		_iTrailEmitterOrientationSet(objptr,orientation.param())
	EndMethod

	Method Cut()
		_iTrailEmitterCut(objptr)
	EndMethod
		
	Method ScaleSet(size:Float)
		_iTrailEmitterScaleSet(objptr,size)
	EndMethod
	
	Method ExpansionSpeedSet(expansion_speed:Float)
		_iTrailEmitterExpansionSpeedSet(objptr, expansion_speed)
	EndMethod
	
EndType

Function iTrailEmitterDestroy(trlemit:TRAILEMITTER)
	trlemit.Destroy()
EndFunction

Function iTrailEmitterEmit(trlemit:TRAILEMITTER,particlesPerSecond:Float,initialAlphaIntensity:Float)
	trlemit.Emit(particlesPerSecond,initialAlphaIntensity)
EndFunction

Function iTrailEmitterLocationSet(trlemit:TRAILEMITTER,location:D3DXVECTOR3)
	trlemit.LocationSet(location)
EndFunction

Function iTrailEmitterOrientationSet(trlemit:TRAILEMITTER,orientation:D3DXQUATERNION)
	trlemit.OrientationSet(orientation)
EndFunction

Function iTrailEmitterCut(trlemit:TRAILEMITTER)
	trlemit.Cut()
EndFunction

Function iTrailEmitterScaleSet(trlemit:TRAILEMITTER,size:Float)
	trlemit.ScaleSet(size)
EndFunction

Function iTrailEmitterExpansionSpeedSet(trlemit:TRAILEMITTER, expansion_speed:Float)
	trlemit.ExpansionSpeedSet(expansion_speed)
EndFunction

Extern
	' TRAIL
	Function _iTrailCreate:Byte Ptr(img_filename$z,maxSegments:Int)="iTrailCreate" ' returns TRAIL* 
	Function _iTrailCreateFromMemory:Byte Ptr(img_memfile_ptr:Byte Ptr,img_memsize:Int,textureID:Int,maxSegments:Int)="iTrailCreateFromMemory" ' returns TRAIL*

	Function _iTrailDestroy(TRAIL:Byte Ptr)="iTrailDestroy"
	Function _iTrailHide(TRAIL:Byte Ptr)="iTrailHide"
	Function _iTrailShow(TRAIL:Byte Ptr)="iTrailShow"
	Function _iTrailRenderModeSet(TRAIL:Byte Ptr,renderMode:Int)="iTrailRenderModeSet"
	Function _iTrailLifeTimeSet(TRAIL:Byte Ptr,lifetime:Float)="iTrailLifeTimeSet"
	Function _iTrailColorSet(TRAIL:Byte Ptr,D3DXVECTOR3_initialRGB:Byte Ptr,D3DXVECTOR3_finalRGB:Byte Ptr)="iTrailColorSet"
	Function _iTrailReset(TRAIL:Byte Ptr)="iTrailReset"
	Function _iTrailEmitterCreate:Byte Ptr(TRAIL:Byte Ptr)="iTrailEmitterCreate" ' returns TRAILEMITTER* 
	Function _iTrailEmitterDestroy(TRAILEMITTER:Byte Ptr)="iTrailEmitterDestroy"
	Function _iTrailEmitterEmit(TRAILEMITTER:Byte Ptr,segmentsPerSecond:Float,intialAlphaIntensity:Float)="iTrailEmitterEmit"
	Function _iTrailEmitterLocationSet(TRAILEMITTER:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iTrailEmitterLocationSet"
	Function _iTrailEmitterScaleSet(TRAILEMITTER:Byte Ptr,size:Float)="iTrailEmitterScaleSet"
	Function _iTrailEmitterCut(TRAILEMITTER:Byte Ptr)="iTrailEmitterCut"
	Function _iTrailEmitterOrientationSet(TRAILEMITTER:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iTrailEmitterOrientationSet"
	Function _iTrailEnvMapCasterAdd(TRAIL:Byte Ptr)="iTrailEnvMapCasterAdd"
	Function _iTrailEnvMapCasterRemove(TRAIL:Byte Ptr)="iTrailEnvMapCasterRemove"
	Function _iTrailTextureSet(TRAIL:Byte Ptr,TEXTURE:Byte Ptr)="iTrailTextureSet"
	Function _iTrailTextureReset(TRAIL:Byte Ptr)="iTrailTextureReset"
	Function _iTrailEmitterExpansionSpeedSet(TRAILEMITTER:Byte Ptr, expansion_speed:Float) = "iTrailEmitterExpansionSpeedSet"
EndExtern
